"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const minimist_1 = __importDefault(require("minimist"));
const minimist_options_1 = __importDefault(require("minimist-options"));
const nodom_1 = require("nodom");
const process_1 = require("process");
const ipynb2html = __importStar(require("ipynb2html"));
const page_1 = __importDefault(require("./page"));
// eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
const { version, bugs: bugsUrl } = { "version": "0.4.0-rc.1", "bugs": "https://github.com/jirutka/ipynb2html/issues" };
const notebookCss = "/* Reference styles for ipynb2html */\n\n.nb-notebook {\n  line-height: 1.5;\n}\n\n.nb-cell + .nb-cell {\n  margin-top: 1.4rem;\n}\n\n.nb-raw-cell {\n  font-family: monospace;\n  white-space: pre-wrap;\n}\n\n.nb-code-cell {\n  position: relative;\n}\n\n.nb-source::before,\n.nb-output::before {\n  position: absolute;\n  font-family: monospace;\n  color: #999;\n  left: -7.5em;\n  width: 7em;\n  text-align: right;\n}\n\n.nb-source::before {\n  content: \"In [\" attr(data-execution-count) \"]:\";\n}\n.nb-output::before {\n  content: \"Out[\" attr(data-execution-count) \"]:\";\n}\n\n.nb-source + .nb-output,\n.nb-output + .nb-output {\n  margin-top: 1.4rem;\n}\n\n.nb-source > pre {\n  background-color: #f7f7f7;\n  border: 1px solid #cfcfcf;\n  border-radius: 2px;\n  padding: 0.5em;\n  margin: 0;\n  overflow-x: auto;\n}\n\n.nb-output {\n  min-height: 1em;\n  width: 100%;\n}\n\n.nb-output > pre {\n  padding: 0.5em;\n  margin: 0;\n  overflow-x: auto;\n}\n\n.nb-output > img {\n  max-width: 100%;\n}\n\n.nb-stdout,\n.nb-stderr {\n  white-space: pre-wrap;\n}\n\n.nb-error,\n.nb-stderr {\n  background-color: #fdd;\n  border-radius: 2px;\n}\n\n@media (max-width: 768px) {\n  .nb-source::before,\n  .nb-output::before {\n    display: block;\n    position: relative;\n    left: 0;\n    padding-bottom: 0.5em;\n    text-align: left;\n  }\n}\n";
const pageCss = "html, body {\n  margin: 0;\n  padding: 0;\n  background-color: #dedede;\n  color: #2a2a2a;\n  font-family: sans-serif;\n}\n\ncode,\npre {\n  font-size: 0.85rem;\n}\n\nh1, h2, h3, h4, h5, h6 {\n  margin-top: 1.6em;\n  position: relative;\n}\nh1 {\n  font-size: 2em;\n}\n\nh1 .anchor,\nh2 .anchor,\nh3 .anchor,\nh4 .anchor,\nh5 .anchor,\nh6 .anchor {\n  display: block;\n  width: 1em;\n  left: -1em;\n  height: 100%;\n  position: absolute;\n}\n\nh1:hover .anchor,\nh2:hover .anchor,\nh3:hover .anchor,\nh4:hover .anchor,\nh5:hover .anchor,\nh6:hover .anchor {\n  background: url(\"data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 50 50'%3E%3Cg fill='none' stroke='%23000' stroke-width='3'%3E%3Cpath d='M26.1 22a5.8 5.8 0 00-8.1 0l-9.6 9.5a5.8 5.8 0 008.2 8.2l5.8-5.9'/%3E%3Cpath d='M23.6 28a5.8 5.8 0 008.2 0l9.5-9.5a5.8 5.8 0 00-8.1-8.2l-5.8 5.9'/%3E%3C/g%3E%3C/svg%3E\") no-repeat 100% center;\n}\n\ntable {\n  border-collapse: collapse;\n  border: 1px solid #cfcfcf;\n}\n\nth {\n  font-weight: 600;\n}\n\ntd,\nth {\n  padding: 0.2em 0.4em;\n  border: 1px solid #cfcfcf;\n}\n\nthead tr,\ntbody tr:nth-child(even) {\n  background-color: #f7f7f7;\n}\n\nthead tr:hover,\ntbody tr:hover {\n  background-color: #cfcfcf;\n}\n\n.nb-notebook {\n  max-width: 45rem;\n  margin: 1rem auto;\n  padding: 3rem 6rem;\n  background-color: white;\n  box-shadow: 4px 4px 8px #cfcfcf, -4px -4px 8px #cfcfcf;\n}\n\n.nb-output table {\n  font-size: 0.9em;\n}\n\n@media (max-width: 900px) {\n  .nb-notebook {\n    margin: 0;\n    padding-left: 5rem;\n    padding-right: 3rem;\n    max-width: none;\n    box-shadow: none;\n  }\n}\n\n@media (max-width: 768px) {\n  .nb-notebook {\n    padding: 1rem 5% 2rem 5%;\n  }\n}\n";
const progName = 'ipynb2html';
const helpMsg = `\
Usage: ${progName} [options] <input> [<output>]

Convert Jupyter Notebook 4.0+ to a static HTML page.

Arguments:
  <input>          Path of the Jupyter notebook to read, or "-" for STDIN.
  <output>         Path of the file to write the output HTML into. If not
                   provided, the output will be written to STDOUT.

Options:
  -d --debug             Print debug messages.

  -s --style <file,...>  Comma separated stylesheet(s) to embed into the output
                         HTML. The stylesheet may be a path to a CSS file,
                         "@base" for the base ipynb2html style, or "@default"
                         for the default full page style. Default is @default.

  -h --help              Show this message and exit.

  -V --version           Print version and exit.

Exit Codes:
  1                      Generic error code.
  2                      Missing required arguments or invalid option.

Please report bugs at <${bugsUrl}>.
`;
function logErr(msg) {
    console.error(`${progName}: ${msg}`);
}
function arrify(obj) {
    return Array.isArray(obj) ? obj : [obj];
}
function parseCliArgs(argv) {
    const opts = minimist_1.default(argv, minimist_options_1.default({
        debug: { alias: 'd', type: 'boolean' },
        style: { alias: 's', type: 'string', default: '@default' },
        version: { alias: 'V', type: 'boolean' },
        help: { alias: 'h', type: 'boolean' },
        arguments: 'string',
        stopEarly: true,
        unknown: (arg) => {
            if (arg.startsWith('-')) {
                logErr(`Unknown option: ${arg}`);
                return process_1.exit(2);
            }
            else {
                return true;
            }
        },
    }));
    if (opts.help) {
        console.log(helpMsg);
        return process_1.exit(0);
    }
    if (opts.version) {
        console.log(`${progName} ${version}`);
        return process_1.exit(0);
    }
    if (opts._.length < 1 || opts._.length > 2) {
        logErr('Invalid number of arguments\n');
        console.log(helpMsg);
        return process_1.exit(2);
    }
    const [input, output] = opts._;
    return {
        styles: arrify(opts.style).join(',').split(/,\s*/),
        debug: opts.debug,
        input: input === '-' ? 0 : input,
        output,
    };
}
function loadStyle(name) {
    switch (name) {
        case '@base': return notebookCss;
        case '@default': return pageCss + notebookCss;
        default: return fs_1.default.readFileSync(name, 'utf8');
    }
}
const cli = (argv) => {
    const opts = parseCliArgs(argv);
    try {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
        const notebook = JSON.parse(fs_1.default.readFileSync(opts.input, 'utf-8'));
        const style = opts.styles.map(loadStyle).join('\n');
        const title = ipynb2html.readNotebookTitle(notebook) || 'Notebook';
        const renderNotebook = ipynb2html.createRenderer(new nodom_1.Document());
        const contents = renderNotebook(notebook).outerHTML;
        const html = page_1.default({ contents, title, style });
        if (opts.output) {
            fs_1.default.writeFileSync(opts.output, html);
        }
        else {
            console.log(html);
        }
    }
    catch (err) {
        if (opts.debug) {
            console.debug(err);
        }
        else {
            logErr(err.message);
        }
        return process_1.exit(1);
    }
};
exports.default = cli;
//# sourceMappingURL=cli.js.map